﻿// Copyright (C) 2011 Oliver Sturm <oliver@oliversturm.com>. All rights reserved.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ThrowingExceptions {
  class Program {
    static void Main(string[] args) {
      // The C# compiler won't let us throw anything that's not derived from Exception:
      //var ex = new Exception("Something went wrong");
      //throw (object) ex;
    }

    static int DivideAByB(int a, int b) {
      if (b == 0)
        throw new ArgumentException("Value must not be zero.", "b");
      return a / b;
    }
  }

  public class ConfigFile {
    ConfigFileState state;
    public ConfigFileState State {
      get { return state; }
    }

    public ConfigFile(ConfigFileState state) {
      this.state = state;
    }

    public void WriteToFile(string content) {
      if (state != ConfigFileState.OpenForWriting)
        throw new InvalidOperationException("Can't write to file because it's not open for writing.");
      // ...
    }

    public string ReadFromFile( ) {
      if (state != ConfigFileState.OpenForReading)
        throw new InvalidOperationException("Can't read from file because it's not open for reading.");
      // ..
      return String.Empty;
    }
  }

  public enum ConfigFileState {
    OpenForReading,
    OpenForWriting
  }

}
